import { CommandResult, InstallOptions, PackageManager, UninstallOptions, UpdateOptions } from "../package-manager";
export declare class Npm extends PackageManager {
    /** Executes a "raw" npm command */
    private command;
    /** Installs the given packages using npm */
    install(packages?: string[], options?: InstallOptions): Promise<CommandResult>;
    uninstall(packages: string[], options?: UninstallOptions): Promise<CommandResult>;
    update(packages?: string[], options?: UpdateOptions): Promise<CommandResult>;
    rebuild(packages?: string[]): Promise<CommandResult>;
    detect(requireLockfile?: boolean, setCwdToPackageRoot?: boolean): Promise<boolean>;
    version(): Promise<string>;
    overrideDependencies(dependencies: Record<string, string>): Promise<CommandResult>;
}
